<a id="mypy-boto3-servicediscovery"></a>

# mypy-boto3-servicediscovery

[![PyPI - types-aiobotocore-servicediscovery](https://img.shields.io/pypi/v/types-aiobotocore-servicediscovery.svg?color=blue)](https://pypi.org/project/types-aiobotocore-servicediscovery)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/types-aiobotocore-servicediscovery.svg?color=blue)](https://pypi.org/project/types-aiobotocore-servicediscovery)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dm/types-aiobotocore-servicediscovery?color=blue)](https://pypistats.org/packages/types-aiobotocore-servicediscovery)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/main/logo.png)

Type annotations for
[boto3.ServiceDiscovery 1.20.47](https://boto3.amazonaws.com/v1/documentation/api/latest/reference/services/servicediscovery.html#ServiceDiscovery)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-builder 6.4.2](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[types-aiobotocore-servicediscovery docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_servicediscovery/)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/main/demo.gif)

- [mypy-boto3-servicediscovery](#mypy-boto3-servicediscovery)
  - [How to install](#how-to-install)
    - [VSCode extension](#vscode-extension)
    - [From PyPI with pip](#from-pypi-with-pip)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Paginators annotations](#paginators-annotations)

<a id="how-to-install"></a>

## How to install

<a id="vscode-extension"></a>

### VSCode extension

Add
[AWS Boto3](https://marketplace.visualstudio.com/items?itemName=Boto3typed.boto3-ide)
extension to your VSCode and run `AWS boto3: Quick Start` command.

Click `Modify` and select `boto3 common` and `ServiceDiscovery`.

<a id="from-pypi-with-pip"></a>

### From PyPI with pip

Install `types-aiobotocore` for `ServiceDiscovery` service.

```bash
# install with aiobotocore type annotations
python -m pip install 'types-aiobotocore[servicediscovery]'

# Lite version does not provide session.create_client overloads
# it is more RAM-friendly, but requires explicit type annotations
python -m pip install 'types-aiobotocore-lite[servicediscovery]'

# standalone installation
python -m pip install types-aiobotocore-servicediscovery
```

<a id="usage"></a>

## Usage

<a id="vscode"></a>

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `types-aiobotocore[servicediscovery]` in your environment:
  `python -m pip install 'types-aiobotocore[servicediscovery]'`

Both type checking and auto-complete should work for `ServiceDiscovery`
service. No explicit type annotations required, write your `boto3` code as
usual.

<a id="pycharm"></a>

### PyCharm

- Install `types-aiobotocore[servicediscovery]` in your environment:
  `python -m pip install 'types-aiobotocore[servicediscovery]'`

Both type checking and auto-complete should work for `ServiceDiscovery`
service. No explicit type annotations required, write your `aiobotocore` code
as usual. Auto-complete can be slow on big projects or if you have a lot of
installed `types-aiobotocore` submodules.

<a id="other-ides"></a>

### Other IDEs

Not tested, but as long as your IDE supports `mypy` or `pyright`, everything
should work.

<a id="mypy"></a>

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `types-aiobotocore[servicediscovery]` in your environment:
  `python -m pip install 'types-aiobotocore[servicediscovery]'`
- Run `mypy` as usual

Type checking should work for `ServiceDiscovery` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="pyright"></a>

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `types-aiobotocore[servicediscovery]` in your environment:
  `python -m pip install 'types-aiobotocore[servicediscovery]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `ServiceDiscovery` service. No explicit type
annotations required, write your `aiobotocore` code as usual.

<a id="explicit-type-annotations"></a>

## Explicit type annotations

<a id="client-annotations"></a>

### Client annotations

`ServiceDiscoveryClient` provides annotations for
`session.create_client("servicediscovery")`.

```python
from aiobotocore.session import get_session

from types_aiobotocore_servicediscovery import ServiceDiscoveryClient

session = get_session()
async with session.create_client("servicediscovery") as client:
    client: ServiceDiscoveryClient
    # now client usage is checked by mypy and IDE should provide code auto-complete
```

<a id="paginators-annotations"></a>

### Paginators annotations

`types_aiobotocore_servicediscovery.paginator` module contains type annotations
for all paginators.

````python
from aiobotocore.session import get_session

from types_aiobotocore_servicediscovery import ServiceDiscoveryClient
from types_aiobotocore_servicediscovery.paginator import (
    ListInstancesPaginator,
    ListNamespacesPaginator,
    ListOperationsPaginator,
    ListServicesPaginator,
)

session = get_session()
async with session.create_client("servicediscovery") as client:
    client: ServiceDiscoveryClient

    # Explicit type annotations are optional here
    # Type should be correctly discovered by mypy and IDEs
    # VSCode requires explicit type annotations
        list_instances_paginator: ListInstancesPaginator = client.get_paginator("list_instances")
        list_namespaces_paginator: ListNamespacesPaginator = client.get_paginator("list_namespaces")
        list_operations_paginator: ListOperationsPaginator = client.get_paginator("list_operations")
        list_services_paginator: ListServicesPaginator = client.get_paginator("list_services")
    ```







### Literals

`types_aiobotocore_servicediscovery.literals` module contains literals extracted from shapes
that can be used in user code for type checking.

```python
from types_aiobotocore_servicediscovery.literals import (
    CustomHealthStatusType,
    FilterConditionType,
    HealthCheckTypeType,
    HealthStatusFilterType,
    HealthStatusType,
    ListInstancesPaginatorName,
    ListNamespacesPaginatorName,
    ListOperationsPaginatorName,
    ListServicesPaginatorName,
    NamespaceFilterNameType,
    NamespaceTypeType,
    OperationFilterNameType,
    OperationStatusType,
    OperationTargetTypeType,
    OperationTypeType,
    RecordTypeType,
    RoutingPolicyType,
    ServiceFilterNameType,
    ServiceTypeOptionType,
    ServiceTypeType,
    ServiceName,
    PaginatorName,
)

def check_value(value: CustomHealthStatusType) -> bool:
    ...
````

### Typed dictionaries

`types_aiobotocore_servicediscovery.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from types_aiobotocore_servicediscovery.type_defs import (
    CreateHttpNamespaceRequestRequestTypeDef,
    CreateHttpNamespaceResponseTypeDef,
    CreatePrivateDnsNamespaceRequestRequestTypeDef,
    CreatePrivateDnsNamespaceResponseTypeDef,
    CreatePublicDnsNamespaceRequestRequestTypeDef,
    CreatePublicDnsNamespaceResponseTypeDef,
    CreateServiceRequestRequestTypeDef,
    CreateServiceResponseTypeDef,
    DeleteNamespaceRequestRequestTypeDef,
    DeleteNamespaceResponseTypeDef,
    DeleteServiceRequestRequestTypeDef,
    DeregisterInstanceRequestRequestTypeDef,
    DeregisterInstanceResponseTypeDef,
    DiscoverInstancesRequestRequestTypeDef,
    DiscoverInstancesResponseTypeDef,
    DnsConfigChangeTypeDef,
    DnsConfigTypeDef,
    DnsPropertiesTypeDef,
    DnsRecordTypeDef,
    GetInstanceRequestRequestTypeDef,
    GetInstanceResponseTypeDef,
    GetInstancesHealthStatusRequestRequestTypeDef,
    GetInstancesHealthStatusResponseTypeDef,
    GetNamespaceRequestRequestTypeDef,
    GetNamespaceResponseTypeDef,
    GetOperationRequestRequestTypeDef,
    GetOperationResponseTypeDef,
    GetServiceRequestRequestTypeDef,
    GetServiceResponseTypeDef,
    HealthCheckConfigTypeDef,
    HealthCheckCustomConfigTypeDef,
    HttpInstanceSummaryTypeDef,
    HttpNamespaceChangeTypeDef,
    HttpPropertiesTypeDef,
    InstanceSummaryTypeDef,
    InstanceTypeDef,
    ListInstancesRequestRequestTypeDef,
    ListInstancesResponseTypeDef,
    ListNamespacesRequestRequestTypeDef,
    ListNamespacesResponseTypeDef,
    ListOperationsRequestRequestTypeDef,
    ListOperationsResponseTypeDef,
    ListServicesRequestRequestTypeDef,
    ListServicesResponseTypeDef,
    ListTagsForResourceRequestRequestTypeDef,
    ListTagsForResourceResponseTypeDef,
    NamespaceFilterTypeDef,
    NamespacePropertiesTypeDef,
    NamespaceSummaryTypeDef,
    NamespaceTypeDef,
    OperationFilterTypeDef,
    OperationSummaryTypeDef,
    OperationTypeDef,
    PaginatorConfigTypeDef,
    PrivateDnsNamespaceChangeTypeDef,
    PrivateDnsNamespacePropertiesChangeTypeDef,
    PrivateDnsNamespacePropertiesTypeDef,
    PrivateDnsPropertiesMutableChangeTypeDef,
    PrivateDnsPropertiesMutableTypeDef,
    PublicDnsNamespaceChangeTypeDef,
    PublicDnsNamespacePropertiesChangeTypeDef,
    PublicDnsNamespacePropertiesTypeDef,
    PublicDnsPropertiesMutableChangeTypeDef,
    PublicDnsPropertiesMutableTypeDef,
    RegisterInstanceRequestRequestTypeDef,
    RegisterInstanceResponseTypeDef,
    ResponseMetadataTypeDef,
    SOAChangeTypeDef,
    SOATypeDef,
    ServiceChangeTypeDef,
    ServiceFilterTypeDef,
    ServiceSummaryTypeDef,
    ServiceTypeDef,
    TagResourceRequestRequestTypeDef,
    TagTypeDef,
    UntagResourceRequestRequestTypeDef,
    UpdateHttpNamespaceRequestRequestTypeDef,
    UpdateHttpNamespaceResponseTypeDef,
    UpdateInstanceCustomHealthStatusRequestRequestTypeDef,
    UpdatePrivateDnsNamespaceRequestRequestTypeDef,
    UpdatePrivateDnsNamespaceResponseTypeDef,
    UpdatePublicDnsNamespaceRequestRequestTypeDef,
    UpdatePublicDnsNamespaceResponseTypeDef,
    UpdateServiceRequestRequestTypeDef,
    UpdateServiceResponseTypeDef,
)

def get_structure() -> CreateHttpNamespaceRequestRequestTypeDef:
    return {
      ...
    }
```

## Versioning

`types-aiobotocore-servicediscovery` version is the same as related `boto3`
version and follows [PEP 440](https://www.python.org/dev/peps/pep-0440/)
format.

## Documentation

All type annotations can be found in
[types-aiobotocore-servicediscovery docs](https://vemel.github.io/types_aiobotocore_docs/types_aiobotocore_servicediscovery/)

## Support and contributing

This package is auto-generated. Please reports any bugs or request new features
in [mypy-boto3-builder](https://github.com/vemel/mypy_boto3_builder/issues/)
repository.
